package net.kldp.OpenSigner.applet;

import java.applet.Applet;
import java.awt.Button;
import java.awt.FileDialog;
import java.awt.Frame;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.security.Key;
import java.security.KeyStore;
import java.security.Principal;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.Security;
import java.security.cert.Certificate;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Enumeration;
import java.util.HashMap;

import javax.crypto.Cipher;
import javax.crypto.CipherInputStream;
import javax.crypto.CipherOutputStream;
import javax.crypto.KeyGenerator;
import javax.crypto.SecretKey;

import org.bouncycastle.jce.provider.BouncyCastleProvider;
import net.kldp.OpenSigner.utils.Base64;
import net.kldp.OpenSigner.utils.StringUtil;
import net.kldp.OpenSigner.utils.xmldsigUtil;
import netscape.javascript.JSObject;

class Controller // He does dirty job
{
	String signitflag = "";
	
	private JSObject myBrowser;
	private JSObject myDocument; 
	private JSObject myForm; 
	private JSObject myInput; 
	private JSObject myPassword;
	private JSObject myOutput;
	
	public Controller(Signer main)
	{
		myBrowser = JSObject.getWindow(main);
		myDocument =  (JSObject)myBrowser.getMember("document");
		myForm = (JSObject)myDocument.getMember(main.getParameter("form_name"));
		myInput = (JSObject)myForm.getMember(main.getParameter("signer_input_holder"));
		myPassword = (JSObject)myForm.getMember(main.getParameter("signer_password_holder"));
		myOutput = (JSObject)myForm.getMember(main.getParameter("signer_output_holder"));	
	}
	
	public void showMessage(String msg)
	{
		String args[] = new String[1]; // why?
		args[0] = msg;
		myBrowser.call("show_message",args);
	}
	
	public String get(String type)
	{
		if(type=="UI.password")
			return (String)myPassword.getMember("value");
		if(type=="UI.input_form")
			return (String)myInput.getMember("value");
		if(type=="UI.output_form")
			return (String)myOutput.getMember("value");
		showMessage("Exception occurs in Controller.java");
		return "";
	}
	
	public void set(String type,String content)
	{
		if(type=="UI.input_form")
			myInput.setMember("value", content);
		if(type=="UI.output_form")
			myOutput.setMember("value", content);			
	}
	
}